# Class GcInfo

java.lang.Object
com.sun.management.GcInfo

All Implemented Interfaces:
  `CompositeData, CompositeDataView`

public class GcInfo extends Object implements CompositeData, CompositeDataView
Garbage collection information. It contains the following information for one garbage collection as well as GC-specific attributes:

> - Start time
> - End time
> - Duration
> - Memory usage before the collection starts
> - Memory usage after the collection ends

`GcInfo` is a `CompositeData` The GC-specific attributes can be obtained via the CompositeData interface. This is a historical relic, and other classes should not copy this pattern. Use `CompositeDataView` instead.

## MXBean Mapping

`GcInfo` is mapped to a `CompositeData` with attributes as specified in the `from` method.

Since:
  1.5

## Method Summary

Modifier and Type
Method
Description
`boolean`
`containsKey(String key)`
Returns `true` if and only if this `CompositeData` instance contains an item whose name is `key`.
`boolean`
`containsValue(Object value)`
Returns `true` if and only if this `CompositeData` instance contains an item whose value is `value`.
`boolean`
`equals(Object obj)`
Compares the specified obj parameter with this `CompositeData` instance for equality.
`static GcInfo`
`from(CompositeData cd)`
Returns a `GcInfo` object represented by the given `CompositeData`.
`Object`
`get(String key)`
Returns the value of the item whose name is `key`.
`Object[]`
`getAll(String[] keys)`
Returns an array of the values of the items whose names are specified by `keys`, in the same order as `keys`.
`CompositeType`
`getCompositeType()`
Returns the composite type of this composite data instance.
`long`
`getDuration()`
Returns the elapsed time of this GC in milliseconds.
`long`
`getEndTime()`
Returns the end time of this GC in milliseconds since the Java virtual machine was started.
`long`
`getId()`
Returns the identifier of this garbage collection which is the number of collections that this collector has done.
`Map<String, MemoryUsage>`
`getMemoryUsageAfterGc()`
Returns the memory usage of all memory pools at the end of this GC.
`Map<String, MemoryUsage>`
`getMemoryUsageBeforeGc()`
Returns the memory usage of all memory pools at the beginning of this GC.
`long`
`getStartTime()`
Returns the start time of this GC in milliseconds since the Java virtual machine was started.
`int`
`hashCode()`
Returns the hash code value for this `CompositeData` instance.
`CompositeData`
`toCompositeData(CompositeType ct)`
Return the `CompositeData` representation of this `GcInfo`, including any GC-specific attributes.
`String`
`toString()`
Returns a string representation of this `CompositeData` instance.
`Collection<?>`
`values()`
Returns an unmodifiable Collection view of the item values contained in this `CompositeData` instance.

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Method Details

### getId

public long getId()
Returns the identifier of this garbage collection which is the number of collections that this collector has done.

Returns:
  the identifier of this garbage collection which is the number of collections that this collector has done.

### getStartTime

public long getStartTime()
Returns the start time of this GC in milliseconds since the Java virtual machine was started.

Returns:
  the start time of this GC.

### getEndTime

public long getEndTime()
Returns the end time of this GC in milliseconds since the Java virtual machine was started.

Returns:
  the end time of this GC.

### getDuration

public long getDuration()
Returns the elapsed time of this GC in milliseconds.

Returns:
  the elapsed time of this GC in milliseconds.

### getMemoryUsageBeforeGc

public Map<String, MemoryUsage> getMemoryUsageBeforeGc()
Returns the memory usage of all memory pools at the beginning of this GC. This method returns a `Map` of the name of a memory pool to the memory usage of the corresponding memory pool before GC starts.

Returns:
  a `Map` of memory pool names to the memory usage of a memory pool before GC starts.

### getMemoryUsageAfterGc

public Map<String, MemoryUsage> getMemoryUsageAfterGc()
Returns the memory usage of all memory pools at the end of this GC. This method returns a `Map` of the name of a memory pool to the memory usage of the corresponding memory pool when GC finishes.

Returns:
  a `Map` of memory pool names to the memory usage of a memory pool when GC finishes.

### from

public static GcInfo from(CompositeData cd)
Returns a `GcInfo` object represented by the given `CompositeData`. The given `CompositeData` must contain all the following attributes:

> description
> Attribute Name | Type
> --- | ---
> index | `java.lang.Long`
> startTime | `java.lang.Long`
> endTime | `java.lang.Long`
> memoryUsageBeforeGc | `javax.management.openmbean.TabularData`
> memoryUsageAfterGc | `javax.management.openmbean.TabularData`

Returns:
  a `GcInfo` object represented by `cd` if `cd` is not `null`; `null` otherwise.
Throws:
  `IllegalArgumentException` - if `cd` does not represent a `GcInfo` object with the attributes described above.

### containsKey

public boolean containsKey(String key)
Description copied from interface: `CompositeData`
Returns `true` if and only if this `CompositeData` instance contains an item whose name is `key`. If `key` is a null or empty String, this method simply returns false.

Specified by:
  `containsKey` in interface `CompositeData`
Parameters:
  `key` - the key to be tested.
Returns:
  true if this `CompositeData` contains the key.

### containsValue

public boolean containsValue(Object value)
Description copied from interface: `CompositeData`
Returns `true` if and only if this `CompositeData` instance contains an item whose value is `value`.

Specified by:
  `containsValue` in interface `CompositeData`
Parameters:
  `value` - the value to be tested.
Returns:
  true if this `CompositeData` contains the value.

### equals

public boolean equals(Object obj)
Description copied from interface: `CompositeData`
Compares the specified obj parameter with this `CompositeData` instance for equality.

Returns `true` if and only if all of the following statements are true:

- obj is non null,
- obj also implements the `CompositeData` interface,
- their composite types are equal
- their contents, i.e. (name, value) pairs are equal. If a value contained in the content is an array, the value comparison is done as if by calling the `deepEquals` method for arrays of object reference types or the appropriate overloading of `Arrays.equals(e1,e2)` for arrays of primitive types

This ensures that this `equals` method works properly for obj parameters which are different implementations of the `CompositeData` interface, with the restrictions mentioned in the `equals` method of the `java.util.Collection` interface.

Specified by:
  `equals` in interface `CompositeData`
Overrides:
  `equals` in class `Object`
Parameters:
  `obj` - the object to be compared for equality with this `CompositeData` instance.
Returns:
  `true` if the specified object is equal to this `CompositeData` instance.
See Also:
  - `Object.hashCode()`
  - `HashMap`

### get

public Object get(String key)
Description copied from interface: `CompositeData`
Returns the value of the item whose name is `key`.

Specified by:
  `get` in interface `CompositeData`
Parameters:
  `key` - the name of the item.
Returns:
  the value associated with this key.

### getAll

public Object[] getAll(String[] keys)
Description copied from interface: `CompositeData`
Returns an array of the values of the items whose names are specified by `keys`, in the same order as `keys`.

Specified by:
  `getAll` in interface `CompositeData`
Parameters:
  `keys` - the names of the items.
Returns:
  the values corresponding to the keys.

### getCompositeType

public CompositeType getCompositeType()
Description copied from interface: `CompositeData`
Returns the composite type of this composite data instance.

Specified by:
  `getCompositeType` in interface `CompositeData`
Returns:
  the type of this CompositeData.

### hashCode

public int hashCode()
Description copied from interface: `CompositeData`
Returns the hash code value for this `CompositeData` instance.

The hash code of a `CompositeData` instance is the sum of the hash codes of all elements of information used in `equals` comparisons (ie: its composite type and all the item values).

This ensures that `t1.equals(t2)` implies that `t1.hashCode()==t2.hashCode()` for any two `CompositeData` instances `t1` and `t2`, as required by the general contract of the method `Object.hashCode()`.

Each item value's hash code is added to the returned hash code. If an item value is an array, its hash code is obtained as if by calling the `deepHashCode` method for arrays of object reference types or the appropriate overloading of `Arrays.hashCode(e)` for arrays of primitive types.

Specified by:
  `hashCode` in interface `CompositeData`
Overrides:
  `hashCode` in class `Object`
Returns:
  the hash code value for this `CompositeData` instance
See Also:
  - `Object.equals(java.lang.Object)`
  - `System.identityHashCode(Object)`

### toString

public String toString()
Description copied from interface: `CompositeData`
Returns a string representation of this `CompositeData` instance.

The string representation consists of the name of the implementing class, the string representation of the composite type of this instance, and the string representation of the contents (ie list the itemName=itemValue mappings).

Specified by:
  `toString` in interface `CompositeData`
Overrides:
  `toString` in class `Object`
Returns:
  a string representation of this `CompositeData` instance

### values

public Collection<?> values()
Description copied from interface: `CompositeData`
Returns an unmodifiable Collection view of the item values contained in this `CompositeData` instance. The returned collection's iterator will return the values in the ascending lexicographic order of the corresponding item names.

Specified by:
  `values` in interface `CompositeData`
Returns:
  the values.

### toCompositeData

public CompositeData toCompositeData(CompositeType ct)
Return the `CompositeData` representation of this `GcInfo`, including any GC-specific attributes. The returned value will have at least all the attributes described in the `from` method, plus optionally other attributes.

Specified by:
  `toCompositeData` in interface `CompositeDataView`
Parameters:
  `ct` - the `CompositeType` that the caller expects. This parameter is ignored and can be null.
Returns:
  the `CompositeData` representation.